﻿using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WDC_BarChart
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            List<Data> dataSource = this.CreateData();

            NumericYAxis yAxis = new NumericYAxis();
            yAxis.MinimumValue = 0;
            yAxis.MaximumValue = 160;

            CategoryXAxis xAxis = new CategoryXAxis();
            xAxis.DataSource = dataSource;
            xAxis.Label = "Year";
            xAxis.Interval = 1;
            xAxis.Gap = 10;

            StackedColumnSeries series = new StackedColumnSeries();
            series.DataSource = dataSource;
            series.XAxis = xAxis;
            series.YAxis = yAxis;

            StackedFragmentSeries fragmentProcutA = new StackedFragmentSeries();
            fragmentProcutA.ValueMemberPath = "ProductA";
            fragmentProcutA.Title = "Product A - Used";
            series.Series.Add(fragmentProcutA);

            StackedFragmentSeries fragmentProcutB = new StackedFragmentSeries();
            fragmentProcutB.ValueMemberPath = "ProductB";
            fragmentProcutB.Title = "Product B - Used";
            series.Series.Add(fragmentProcutB);

            StackedFragmentSeries fragmentProcutC = new StackedFragmentSeries();
            fragmentProcutC.ValueMemberPath = "ProductC";
            fragmentProcutC.Title = "Product C - Used";
            series.Series.Add(fragmentProcutC);

            StackedFragmentSeries fragmentProcutD = new StackedFragmentSeries();
            fragmentProcutD.ValueMemberPath = "ProductD";
            fragmentProcutD.Title = "Product D - Used";
            series.Series.Add(fragmentProcutD);

            LineSeries lineSeries = new LineSeries();
            lineSeries.XAxis = xAxis;
            lineSeries.YAxis = yAxis;
            lineSeries.DataSource = dataSource;
            lineSeries.ValueMemberPath = "TotalAvailable";
            lineSeries.Title = "Total Available";
            lineSeries.Thickness = 5;

            ultraDataChart1.Axes.Add(xAxis);
            ultraDataChart1.Axes.Add(yAxis);

            ultraDataChart1.Series.Add(series);
            ultraDataChart1.Series.Add(lineSeries);
        }

        private List<Data> CreateData()
        {
            var list = new List<Data>();

            list.Add(new Data() { Year = 2016, ProductA = 20, ProductB = 25, ProductC = 10, ProductD = 10, TotalAvailable = 80 });
            list.Add(new Data() { Year = 2017, ProductA = 20, ProductB = 25, ProductC = 10, ProductD = 5 , TotalAvailable = 82 });
            list.Add(new Data() { Year = 2018, ProductA = 20, ProductB = 25, ProductC = 10, ProductD = 30, TotalAvailable = 84 });
            list.Add(new Data() { Year = 2019, ProductA = 15, ProductB = 25, ProductC = 10, ProductD = 5 , TotalAvailable = 140 });
            list.Add(new Data() { Year = 2020, ProductA = 20, ProductB = 10, ProductC = 5 , ProductD = 5 , TotalAvailable = 90 });
            list.Add(new Data() { Year = 2021, ProductA = 20, ProductB = 12, ProductC = 10, ProductD = 5 , TotalAvailable = 86 });
            list.Add(new Data() { Year = 2022, ProductA = 10, ProductB = 12, ProductC = 10, ProductD = 5 , TotalAvailable = 92 });
            list.Add(new Data() { Year = 2023, ProductA = 10, ProductB = 25, ProductC = 10, ProductD = 50, TotalAvailable = 78 });
            list.Add(new Data() { Year = 2024, ProductA = 15, ProductB = 20, ProductC = 8 , ProductD = 5 , TotalAvailable = 100 });
            list.Add(new Data() { Year = 2025, ProductA = 15, ProductB = 25, ProductC = 10, ProductD = 10, TotalAvailable = 100});
            list.Add(new Data() { Year = 2026, ProductA = 20, ProductB = 25, ProductC = 10, ProductD = 5 , TotalAvailable = 105 });
            list.Add(new Data() { Year = 2027, ProductA = 18, ProductB = 13, ProductC = 10, ProductD = 5 , TotalAvailable = 95 });
            list.Add(new Data() { Year = 2028, ProductA = 30, ProductB = 30, ProductC = 20, ProductD = 5 , TotalAvailable = 110 });
            list.Add(new Data() { Year = 2029, ProductA = 20, ProductB = 25, ProductC = 10, ProductD = 5 , TotalAvailable = 120 });
            list.Add(new Data() { Year = 2030, ProductA = 20, ProductB = 25, ProductC = 10, ProductD = 5 , TotalAvailable = 100 });

            return list;
        }
    }

    public class Data
    {
        public int Year { get; set; }
        public int TotalAvailable { get; set; }
        public int ProductA { get; set; }
        public int ProductB { get; set; }
        public int ProductC { get; set; }
        public int ProductD { get; set; }
    }

}
